; Enter the filet radius as part of a command line entry f100 offset O234 circle c123-45 
; note - is used for decimal point
; original code and methology by Alan H
; assistance and code that worked by Lee-Mac
; OCT 2015
 
(   (lambda nil
        (vl-load-com)
        (foreach obj (cdar (vlr-reactors :vlr-command-reactor))
            (if (= "fillet-reactor" (vlr-data obj))
                (vlr-remove obj)
            )
        )
        (vlr-command-reactor "fillet-reactor" '((:vlr-unknowncommand . fillet-reactor-callback)))
    )
)

(defun filletrad ( / rad)
(setq rad (distof (substr com 2) 2))
            (if (<= 0.0 rad)
              (progn        
              (setvar 'filletrad rad)
              (vla-sendcommand fillet-reactor-acdoc "_.fillet ")
              )
              ) 
)

(defun makecirc ( / rad radd)
(setvar 'users1 (substr com 2 2))
(setq rad (distof (substr com 2) 2))
            (if (<= 0.0 rad)
            (progn 
            (setvar 'circlerad rad)
            (setq pt (getpoint "Pick centre pt"))       
            (vla-sendcommand fillet-reactor-acdoc "_.Circle !pt  ")       
            )
            )
)

(defun offdist ( / dist)
(setq dist (distof (substr com 2) 2))
            (if (<= 0.0 dist)
            (progn        
            (setvar 'offsetdist dist)
            (vla-sendcommand fillet-reactor-acdoc "_.Offset  ")
            )
            )
)


(defun fillet-reactor-callback ( obj com )
(setq com (vl-string-translate "-" "." (strcase (car com))))
    (cond   
        (   (and
            (wcmatch com "~*[~F.0-9]*")
            (wcmatch com "F*")
            (wcmatch com "~F*F*")
            (wcmatch com "~*.*.*")
            ) ; and
            (filletrad) 
         ) 

         (  (and
            (wcmatch com "~*[~C.0-9]*")
            (wcmatch com "C*")
            (wcmatch com "~C*C*")
            (wcmatch com "~*.*.*")
            ) ;and
            (makecirc) 
         )
(  (and
            (wcmatch com "~*[~T.0-9]*")
            (wcmatch com "T*")
            (wcmatch com "~T*T*")
            (wcmatch com "~*.*.*")
            ) ;and
            (makecirc) 
         )
         (  (and
            (wcmatch com "~*[~O.0-9]*")
            (wcmatch com "O*")
            (wcmatch com "~O*O*")
            (wcmatch com "~*.*.*")
            ) ; and
            (offdist) 
         )

    ) ; master cond
) ; defun

(or fillet-reactor-acdoc
    (setq fillet-reactor-acdoc (vla-get-activedocument (vlax-get-acad-object)))
)
